package com.datacloudsec.utils;

import com.datacloudsec.utils.BASE64Util;
import com.datacloudsec.utils.SecretUtil;
import java.security.Security;
import java.util.Arrays;
import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import org.bouncycastle.jce.provider.BouncyCastleProvider;
import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

public class AES256Util {

   public static final String CBC_NOPADDING = "AES/CBC/NoPadding";
   public static final String CBC_PKCS5 = "AES/CBC/PKCS5Padding";
   public static final String CBC_PKCS7 = "AES/CBC/PKCS7Padding";
   private static final String ECB_PKCS5 = "AES/ECB/PKCS5Padding";


   public static String encrypt(byte[] srcData, byte[] key, byte[] iv, String type) throws Exception {
      SecretKeySpec keySpec = new SecretKeySpec(key, "AES");
      Security.addProvider(new BouncyCastleProvider());
      Cipher cipher = Cipher.getInstance(type);
      cipher.init(1, keySpec, new IvParameterSpec(iv));
      byte[] encData = cipher.doFinal(srcData);
      return BASE64Util.encodeByte(encData);
   }

   public static String decrypt(String encData, byte[] key, byte[] iv, String type) throws Exception {
      SecretKeySpec keySpec = new SecretKeySpec(key, "AES");
      Security.addProvider(new BouncyCastleProvider());
      Cipher cipher = Cipher.getInstance(type);
      cipher.init(2, keySpec, new IvParameterSpec(iv));
      byte[] decbbdt = cipher.doFinal(BASE64Util.decodeToByte(encData));
      return new String(decbbdt, "UTF-8");
   }

   public static String encryptECB(String input, String passwd) throws Exception {
      String cipertext = null;
      Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
      cipher.init(1, getKey(passwd));
      cipertext = (new BASE64Encoder()).encode(cipher.doFinal(input.getBytes("UTF-8")));
      return cipertext;
   }

   public static String decryptECB(String cipertext, String passwd) throws Exception {
      String text = null;
      Cipher cipher = Cipher.getInstance("AES/ECB/PKCS5Padding");
      cipher.init(2, getKey(passwd));
      text = new String(cipher.doFinal((new BASE64Decoder()).decodeBuffer(cipertext)));
      return text;
   }

   private static SecretKeySpec getKey(String key) throws Exception {
      byte[] bitkey = Arrays.copyOf(SecretUtil.digestSha1Byte(key, "sha-256"), 32);
      return new SecretKeySpec(bitkey, "AES");
   }

   public static void main(String[] args) throws Exception {
      String content = "asy123456";
      String password = "b21fc63d8c633ebc";
      System.out.println("明文：" + content);
      System.out.println("key：" + password);
      String encryptResult = encryptECB(content, password);
      System.out.println("密文：" + encryptResult);
      String decryptResult = decryptECB(encryptResult, password);
      System.out.println("解密：" + decryptResult);
   }
}
